(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     44169,       1004]
NotebookOptionsPosition[     41985,        966]
NotebookOutlinePosition[     42389,        982]
CellTagsIndexPosition[     42346,        979]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"m", "=", "700"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", 
   RowBox[{"Ceiling", "[", 
    RowBox[{
     RowBox[{"Sqrt", "[", "2", "]"}], "m"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RandomSeeding", "[", "14", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Z0", "=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"RandomVariate", "[", 
      RowBox[{
       RowBox[{"NormalDistribution", "[", 
        RowBox[{"0", ",", "1"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"2", "n"}], ",", 
         RowBox[{"2", "n"}]}], "}"}]}], "]"}], "+", 
     RowBox[{"I", " ", 
      RowBox[{"RandomVariate", "[", 
       RowBox[{
        RowBox[{"NormalDistribution", "[", 
         RowBox[{"0", ",", "1"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"2", "n"}], ",", 
          RowBox[{"2", "n"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Zs", "=", 
   RowBox[{"RandomVariate", "[", 
    RowBox[{
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"0", ",", "1"}], "]"}], ",", 
     RowBox[{"{", "2", "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.8806418973098235`*^9, 3.8806419917125974`*^9}, 
   3.9211665339486237`*^9, 3.9211666468445697`*^9},
 CellLabel->"In[55]:=",ExpressionUUID->"eb73507e-d015-434d-907a-20be94b15e6e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "=", 
   RowBox[{
    RowBox[{"c", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"c", "^", "2"}], "+", 
        RowBox[{"om", "^", "2"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "3"}], "/", "2"}], ")"}]}]}], "/.", 
    RowBox[{"c", "->", "100"}]}]}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{
   "For", " ", "left", " ", "panel", " ", "of", " ", "Figure", " ", "3"}], 
   "*)"}]}]], "Input",
 CellChangeTimes->{{3.872609704993363*^9, 3.872609716993826*^9}, {
  3.872668019884326*^9, 3.8726680202118263`*^9}, {3.921166039748876*^9, 
  3.9211660804523935`*^9}},
 CellLabel->"In[68]:=",ExpressionUUID->"c0bdc856-5145-46e0-82a3-3a5d6fc67b4e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"200", "^", "2"}], "+", 
       RowBox[{"om", "^", "2"}]}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "6"}], "/", "2"}], ")"}]}], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"50", "^", "2"}], "+", 
       RowBox[{"om", "^", "2"}]}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{"3", "/", "2"}], ")"}]}]}]}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{
   "For", " ", "right", " ", "panel", " ", "of", " ", "Figure", " ", "3"}], 
   "*)"}]}]], "Input",
 CellChangeTimes->{{3.872605861807851*^9, 3.872605870599696*^9}, {
  3.8726126381590176`*^9, 3.87261263884552*^9}, {3.921166087164873*^9, 
  3.9211660909079323`*^9}},
 CellLabel->"In[88]:=",ExpressionUUID->"fc9044ad-4c59-480f-b4e0-aaf4aa07e979"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"f", "=", 
    RowBox[{
     RowBox[{"f", " ", "c", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"c", "^", "2"}], "+", 
         RowBox[{"om", "^", "2"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "3"}], "/", "2"}], ")"}]}]}], "/.", 
     RowBox[{"c", "->", 
      RowBox[{"1", "/", "10"}]}]}]}], ";"}], " ", 
  RowBox[{"(*", 
   RowBox[{
   "For", " ", "both", " ", "panels", " ", "of", " ", "Figure", " ", "3"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f", "=", 
    RowBox[{"f", "/", 
     RowBox[{"(", 
      RowBox[{"f", "/.", 
       RowBox[{"om", "->", "5"}]}], ")"}]}]}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{"f", "=", 
  RowBox[{"f", "/.", 
   RowBox[{"om", "->", 
    RowBox[{"om", " ", "/", 
     RowBox[{"Sqrt", "[", "2", "]"}]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tr", "[", "r_", "]"}], "=", 
  RowBox[{"r", "^", "2"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"out", "=", 
   RowBox[{"ParallelTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"tr", "[", "r", "]"}], ",", 
       RowBox[{"NIntegrate", "[", " ", 
        RowBox[{
         RowBox[{"om", " ", 
          RowBox[{"BesselJ", "[", 
           RowBox[{"0", ",", 
            RowBox[{"om", " ", 
             RowBox[{"tr", "[", "r", "]"}]}]}], "]"}], "f"}], ",", 
         RowBox[{"{", 
          RowBox[{"om", ",", "0", ",", "Infinity"}], "}"}], ",", 
         RowBox[{"MaxRecursion", "\[Rule]", "20"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", "1.24", ",", 
       RowBox[{"1", "/", "100"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"cov", "=", 
  RowBox[{"Interpolation", "[", "out", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"covx", "=", "cov"}], ";", 
  RowBox[{"k1", "=", 
   RowBox[{"10", "^", 
    RowBox[{"(", 
     RowBox[{"-", "50"}], ")"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{
  3.8726050808593693`*^9, {3.8726052230755424`*^9, 3.872605233652363*^9}, {
   3.872605269955431*^9, 3.8726052776119156`*^9}, {3.87260554172578*^9, 
   3.872605617583081*^9}, {3.872605704345064*^9, 3.8726057156066637`*^9}, 
   3.87260589834924*^9, {3.872667154265984*^9, 3.8726671724602003`*^9}, 
   3.872667202703806*^9, {3.921166123757764*^9, 3.9211661282692685`*^9}, 
   3.921166170412406*^9, {3.9211664384366817`*^9, 3.9211664431563425`*^9}},
 CellLabel->"In[89]:=",ExpressionUUID->"ffacb91f-7675-4c3c-a371-b4d026ce727a"],

Cell[BoxData[
 FractionBox[
  RowBox[{"10263315687301", " ", 
   SqrtBox[
    FractionBox["2501", "101"]], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"2500", "+", 
      FractionBox[
       SuperscriptBox["om", "2"], "2"]}], ")"}], 
    RowBox[{"3", "/", "2"}]]}], 
  RowBox[{"808", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", "100"], "+", 
      FractionBox[
       SuperscriptBox["om", "2"], "2"]}], ")"}], 
    RowBox[{"3", "/", "2"}]], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"40000", "+", 
      FractionBox[
       SuperscriptBox["om", "2"], "2"]}], ")"}], "3"]}]]], "Output",
 CellChangeTimes->{{3.8726052589894524`*^9, 3.872605288434741*^9}, {
   3.87260552066903*^9, 3.872605547202179*^9}, {3.872605592186302*^9, 
   3.8726056194218473`*^9}, {3.872605730833807*^9, 3.872605744755577*^9}, {
   3.8726058876193867`*^9, 3.872605902300733*^9}, 3.8726060594039593`*^9, 
   3.8726097221330595`*^9, 3.8726118255577517`*^9, 3.87261264702157*^9, 
   3.872668213980815*^9, 3.8726682805629873`*^9, 3.872668334048103*^9, 
   3.8726684916055927`*^9, 3.8726685550788865`*^9, 3.8726686106005263`*^9, 
   3.872668669962678*^9, 3.872668731035847*^9, 3.8726687970948524`*^9, 
   3.8726688571733017`*^9, 3.8726688942345204`*^9, 3.8726689260693054`*^9, 
   3.874229834975417*^9, 3.874229913751953*^9, 3.874230001081788*^9, 
   3.874230060827942*^9, 3.8744850657949004`*^9, 3.921166689153599*^9, 
   3.921166739334725*^9},
 CellLabel->"Out[91]=",ExpressionUUID->"e1cafed2-4933-4b84-9f9a-8f2f115841c8"],

Cell[BoxData[
 SuperscriptBox["r", "2"]], "Output",
 CellChangeTimes->{{3.8726052589894524`*^9, 3.872605288434741*^9}, {
   3.87260552066903*^9, 3.872605547202179*^9}, {3.872605592186302*^9, 
   3.8726056194218473`*^9}, {3.872605730833807*^9, 3.872605744755577*^9}, {
   3.8726058876193867`*^9, 3.872605902300733*^9}, 3.8726060594039593`*^9, 
   3.8726097221330595`*^9, 3.8726118255577517`*^9, 3.87261264702157*^9, 
   3.872668213980815*^9, 3.8726682805629873`*^9, 3.872668334048103*^9, 
   3.8726684916055927`*^9, 3.8726685550788865`*^9, 3.8726686106005263`*^9, 
   3.872668669962678*^9, 3.872668731035847*^9, 3.8726687970948524`*^9, 
   3.8726688571733017`*^9, 3.8726688942345204`*^9, 3.8726689260693054`*^9, 
   3.874229834975417*^9, 3.874229913751953*^9, 3.874230001081788*^9, 
   3.874230060827942*^9, 3.8744850657949004`*^9, 3.921166689153599*^9, 
   3.9211667393407106`*^9},
 CellLabel->"Out[92]=",ExpressionUUID->"5662886d-122d-4016-b40e-569fad55d441"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox["InterpolatingFunction",
    "SummaryHead"], "[", 
   DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
    TemplateBox[{
      PaneSelectorBox[{False -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource["FEBitmaps", "SummaryBoxOpener"]], 
              ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
              BaseStyle -> {}, Evaluator -> Automatic, Method -> 
              "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 
                3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification])}]], 
            GraphicsBox[{{{{}, {}, 
                TagBox[{
                  Directive[
                   Opacity[1.], 
                   RGBColor[0.368417, 0.506779, 0.709798], 
                   AbsoluteThickness[1]], 
                  LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAA7WfiCJn7Wz7SHTF2K3yjQBIGv/3L
qpk/9tf9juI/o0AyzP2gJL+qP4rtj1czKaNAEbvIsG3esz/NfPqkhhajQF2d
E7GqPLo/GPpZfM4Eo0BuI3Y5ipLAPx/Ey+jl8aJAYND/Ib3Lwz+XKKdwbuCi
QOxgUGsGSsc/2CZWqqTNokAieKGEALjKPyE+/v5Pu6JAiuePpfjqzT/YzPRs
TaqiQEWdopODsdA/MswO+PGXokDe8kvYCVDSPxU/knzihqJAzIv1hGjm0z+/
LAiFOnaiQIeWAmJSn9U/6YyyGDtkokBbTd5CuzrXP674rVSBU6JA/HUdVK/4
2D8XgImMckGiQPLhXM17rto/rbHMr8ovokAB+mpKx0bcP10+OZpjH6JA3YPc
950B3j9NNgOxqg2iQNK5HKnznt8/Cl9dQDD9oUDKMGBFaq/gP6i2FMJm66FA
VSYy6kaL4T+w1566AdqhQO1x6xBjWOI/cQSwDNfJoUBrdtbPxDbjP0Pmnrlg
uKFA9tCoEGYG5D/1SESvIqihQCtNe4Xz0eQ/A0Xn90SYoUBGgn+Sxq7lP90U
ufEeh6FAbg1rIdl85j/jBKByLXehQHxRiEgxXOc/E7ZYafZloUA1t6WjdTfo
P/IjL34gVaFA+nKqgPkD6T+CYmxZe0WhQKbn4PXC4ek/5akdC5Q0oUBesv7s
y7DqP067XpnbJKFAwZ4cGMF76z/b+H5xgBWhQApEbNv7V+w/9Lx9ZOYEoUBg
P6MgdiXtPz5I16d39aBAnPML/jUE7j+zxe+2zOSgQOX9W1011O4/kCVTN0vV
oEDYKazwIKDvP2vRk2clxqBAWQcXDqk+8D/w3nedxrWgQM2ky2ThpfA/VeJ4
yY2moEC0HpmHvBXxP55CiqIelqBAcKlmxI2D8T85y1/9C4agQDLfJ8L+6fE/
P5Yqyht3oEBn8QGMElnyPwnZKoH4ZqBAo67PFsbA8j/mhIXd9VegQLR8nbtv
JvM/PhA1IkxJoEA4J4QsvJTzP3dkknFyOaBAwnxeXqj78z/CBXILtiqgQMCu
UVw3a/Q/cV0MQswaoECT8UR0vNj0Pyzwfi48C6BAbN8rTeE+9T/Kz6YBjPmf
QLipK/KorfU/E+FnJkvan0ALHx9YEBX2P/o0v506vZ9A0XArihqF9j9aJFqm
2p2fQGzTN9Ya8/Y/WnfhCyt/n0AN4Tfjuln3P5TELBSlYp9AIctQvP3I9z9A
Ihjd1UOfQDxgXVbgMPg/WPFh3Cwnn0DJXyZuApr4P8pM5H1GCp9A2gfo2g==

                   "]]}, 
                 Annotation[#, "Charting`Private`Tag$12917#1"]& ]}}, {}}, {
             DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
              AxesOrigin -> {0, 1986.568839614097}, 
              FrameTicks -> {{{}, {}}, {{}, {}}}, GridLines -> {None, None}, 
              DisplayFunction -> Identity, PlotRangePadding -> {{
                 Scaled[0.1], 
                 Scaled[0.1]}, {
                 Scaled[0.1], 
                 Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
              All, DisplayFunction -> Identity, AspectRatio -> 1, 
              Axes -> {False, False}, AxesLabel -> {None, None}, 
              AxesOrigin -> {0, 1986.5688396140927`}, DisplayFunction :> 
              Identity, Frame -> {{True, True}, {True, True}}, 
              FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
              Directive[
                Opacity[0.5], 
                Thickness[Tiny], 
                RGBColor[0.368417, 0.506779, 0.709798]], 
              FrameTicks -> {{None, None}, {None, None}}, 
              GridLines -> {None, None}, GridLinesStyle -> Directive[
                GrayLevel[0.5, 0.4]], ImageSize -> 
              Dynamic[{
                Automatic, 
                 3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                  Magnification])}], 
              Method -> {
               "DefaultBoundaryStyle" -> Automatic, 
                "DefaultGraphicsInteraction" -> {
                 "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                  "Effects" -> {
                   "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                "DefaultMeshStyle" -> AbsolutePointSize[6], 
                "ScalingFunctions" -> None, 
                "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
              PlotRange -> {{0., 1.5376}, {1986.5688396140927`, 
               2494.08488610734}}, PlotRangeClipping -> True, 
              PlotRangePadding -> {{
                 Scaled[0.1], 
                 Scaled[0.1]}, {
                 Scaled[0.1], 
                 Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "1.5376`"}], "}"}], "}"}], 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"scalar\"", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
          AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}], True -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource["FEBitmaps", "SummaryBoxCloser"]], 
              ButtonFunction :> (Typeset`open$$ = False), Appearance -> None, 
              BaseStyle -> {}, Evaluator -> Automatic, Method -> 
              "Preemptive"], Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 
                3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification])}]], 
            GraphicsBox[{{{{}, {}, 
                TagBox[{
                  Directive[
                   Opacity[1.], 
                   RGBColor[0.368417, 0.506779, 0.709798], 
                   AbsoluteThickness[1]], 
                  LineBox[CompressedData["
1:eJwB0QMu/CFib1JlAgAAADwAAAACAAAA7WfiCJn7Wz7SHTF2K3yjQBIGv/3L
qpk/9tf9juI/o0AyzP2gJL+qP4rtj1czKaNAEbvIsG3esz/NfPqkhhajQF2d
E7GqPLo/GPpZfM4Eo0BuI3Y5ipLAPx/Ey+jl8aJAYND/Ib3Lwz+XKKdwbuCi
QOxgUGsGSsc/2CZWqqTNokAieKGEALjKPyE+/v5Pu6JAiuePpfjqzT/YzPRs
TaqiQEWdopODsdA/MswO+PGXokDe8kvYCVDSPxU/knzihqJAzIv1hGjm0z+/
LAiFOnaiQIeWAmJSn9U/6YyyGDtkokBbTd5CuzrXP674rVSBU6JA/HUdVK/4
2D8XgImMckGiQPLhXM17rto/rbHMr8ovokAB+mpKx0bcP10+OZpjH6JA3YPc
950B3j9NNgOxqg2iQNK5HKnznt8/Cl9dQDD9oUDKMGBFaq/gP6i2FMJm66FA
VSYy6kaL4T+w1566AdqhQO1x6xBjWOI/cQSwDNfJoUBrdtbPxDbjP0Pmnrlg
uKFA9tCoEGYG5D/1SESvIqihQCtNe4Xz0eQ/A0Xn90SYoUBGgn+Sxq7lP90U
ufEeh6FAbg1rIdl85j/jBKByLXehQHxRiEgxXOc/E7ZYafZloUA1t6WjdTfo
P/IjL34gVaFA+nKqgPkD6T+CYmxZe0WhQKbn4PXC4ek/5akdC5Q0oUBesv7s
y7DqP067XpnbJKFAwZ4cGMF76z/b+H5xgBWhQApEbNv7V+w/9Lx9ZOYEoUBg
P6MgdiXtPz5I16d39aBAnPML/jUE7j+zxe+2zOSgQOX9W1011O4/kCVTN0vV
oEDYKazwIKDvP2vRk2clxqBAWQcXDqk+8D/w3nedxrWgQM2ky2ThpfA/VeJ4
yY2moEC0HpmHvBXxP55CiqIelqBAcKlmxI2D8T85y1/9C4agQDLfJ8L+6fE/
P5Yqyht3oEBn8QGMElnyPwnZKoH4ZqBAo67PFsbA8j/mhIXd9VegQLR8nbtv
JvM/PhA1IkxJoEA4J4QsvJTzP3dkknFyOaBAwnxeXqj78z/CBXILtiqgQMCu
UVw3a/Q/cV0MQswaoECT8UR0vNj0Pyzwfi48C6BAbN8rTeE+9T/Kz6YBjPmf
QLipK/KorfU/E+FnJkvan0ALHx9YEBX2P/o0v506vZ9A0XArihqF9j9aJFqm
2p2fQGzTN9Ya8/Y/WnfhCyt/n0AN4Tfjuln3P5TELBSlYp9AIctQvP3I9z9A
Ihjd1UOfQDxgXVbgMPg/WPFh3Cwnn0DJXyZuApr4P8pM5H1GCp9A2gfo2g==

                   "]]}, 
                 Annotation[#, "Charting`Private`Tag$12917#1"]& ]}}, {}}, {
             DisplayFunction -> Identity, Ticks -> {Automatic, Automatic}, 
              AxesOrigin -> {0, 1986.568839614097}, 
              FrameTicks -> {{{}, {}}, {{}, {}}}, GridLines -> {None, None}, 
              DisplayFunction -> Identity, PlotRangePadding -> {{
                 Scaled[0.1], 
                 Scaled[0.1]}, {
                 Scaled[0.1], 
                 Scaled[0.1]}}, PlotRangeClipping -> True, ImagePadding -> 
              All, DisplayFunction -> Identity, AspectRatio -> 1, 
              Axes -> {False, False}, AxesLabel -> {None, None}, 
              AxesOrigin -> {0, 1986.5688396140927`}, DisplayFunction :> 
              Identity, Frame -> {{True, True}, {True, True}}, 
              FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
              Directive[
                Opacity[0.5], 
                Thickness[Tiny], 
                RGBColor[0.368417, 0.506779, 0.709798]], 
              FrameTicks -> {{None, None}, {None, None}}, 
              GridLines -> {None, None}, GridLinesStyle -> Directive[
                GrayLevel[0.5, 0.4]], ImageSize -> 
              Dynamic[{
                Automatic, 
                 3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                  Magnification])}], 
              Method -> {
               "DefaultBoundaryStyle" -> Automatic, 
                "DefaultGraphicsInteraction" -> {
                 "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
                  "Effects" -> {
                   "Highlight" -> {"ratio" -> 2}, 
                    "HighlightPoint" -> {"ratio" -> 2}, 
                    "Droplines" -> {
                    "freeformCursorMode" -> True, 
                    "placement" -> {"x" -> "All", "y" -> "None"}}}}, 
                "DefaultMeshStyle" -> AbsolutePointSize[6], 
                "ScalingFunctions" -> None, 
                "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
              PlotRange -> {{0., 1.5376}, {1986.5688396140927`, 
               2494.08488610734}}, PlotRangeClipping -> True, 
              PlotRangePadding -> {{
                 Scaled[0.1], 
                 Scaled[0.1]}, {
                 Scaled[0.1], 
                 Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Domain: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"0.`", ",", "1.5376`"}], "}"}], "}"}], 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Output: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"scalar\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Order: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["3", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"Hermite\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Periodic: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["False", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
          AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}]}, 
       Dynamic[Typeset`open$$], ImageSize -> Automatic]},
     "SummaryPanel"],
    DynamicModuleValues:>{}], "]"}],
  InterpolatingFunction[{{0., 1.5376}}, {
   5, 7, 0, {125}, {4}, 0, 0, 0, 0, Automatic, {}, {}, False}, CompressedData["
1:eJxFkXtIU3EcxacSoSKI1B9mJAZFQ+yPKBHLTmZpBAZKhMXshZaVL7LIZqaZ
ln8U5QMNIbFmYpaWlmmaWL6WTc33Uqdtczl1pptuTv1D2vRAFy6Xe+/39z3n
fI7HxbjQSFuBQGBjuZMF/y+vgK06tfcWrD99kS1LOdaYHMz3M0jaVBGkEkfw
ewxiJTZfNrjc4H8x0tTSZ/V5qZxLR2rNIcunTM4/Rljpvs79J7J4LhcOckm8
n0M+zxdgQHvVczH/OfcUITymdbUq6SX3FUMhv5cQmFvCvaWI+jCdUL35DfeX
Yz3Fe+pUom9M6Zjzuop6H2FZPprzsJq6NXAM3HHTtqCW+nWI78rsHVPW00cD
RE+aTLtEjfTzFZePXInTZ3yjryZEhCsC7RKb6a8Fkmxfm+D0Vvpsw07N/cLO
Min9fsdMSO22DF07fctgGrEOdtB/J/zXhLqYoxtR26MTxa+6macHPVmi1YCV
Hubqpb8+5uuHvVvhWaGsnzkHIN8753M0aJB55WhTVKff6ZYz9y/IXeb9f14a
Yv5hzo2QwwjOCWXO0joFeYxiwN7qaIy6v+F9oCE0z0NJPkrkWOM7qchJxRxq
8lLj7qPP1+yX1eQ2Diel19OipXHy06B8RWSZ1JDjH6yNOU6Q5wTcM3QWglpy
1cJgPH76gc8k+U6i3zPSVR02Rc5TkAp9LWinyVuHjtn25sPlOnKfgUpsFZ4h
/7/Y2OUaMuw2yx5mcXBy6O2KaI459GiOKDt/MlTPXvSw0r2+rGc/BhRbKUsM
7MkAlaWltJB59jWPEgcr+AXyW4Ax+lRyxacF9mfEjz0tlbtjjezRCOHaoIl9
muA8VfPOTmtir4tIGfK7HVa6yN7MuOXl4W6MNrNnM8yaCy8G9y6x7yX8Aw6m
8qA=
   "], {Developer`PackedArrayForm, {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 
    13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 
    31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 
    49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 
    67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 
    85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102,
     103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 
    117, 118, 119, 120, 121, 122, 123, 124, 125}, CompressedData["
1:eJwNk3001XcAxm/NuLG8bGSc2aEO7kXLlJe76Xi8xI7tUkYq5M7pnkymHF01
XAx5m9Wut5yt/H7f77fE8pJs6U5eQtZBZJ1mmVihoohCLXXu7h/P+fz1nOfz
z2MTczBEvkogECi12djhnOyYxpB9Z1wi1jKyz21FT0uNots3LZWhwEEd8kEK
g0GjuDnnCMOfsgLfrCQGowjxfqcEBsGZMMP7+xkukmyZ41cM+yTxG3/cw1CW
8H2NIpRBJ2Ko3zCYobI4vzM6kOGflo9Npf4MylJVVJ0Pw5LfA6NwL4bP3m95
Ye/J4OZcGaMnYUg6MmM45cqgd2lh+pILw5lH46PJm7Q7AeliGyeGugtPZU0i
rWep0YCjLcOvPSn2BTYMzUpFbK8Vwx332StzFgwLvkHJS2YMEmmMzpiJ1t9D
NH9uLUNTRe9wyBqGgKKdB8Z0GKK+0IkLFDAMdixy5SsUHwYFT3YuU3hLG8wH
FyhMSm6tb3lCEdmWs5T7kOLA0+pjLvcpquyUA62jFFfGZwdFwxRvn15zPGmI
4pROgXFlH0XXYmxM9TWK6JMlquJ2igVBeX2kmmIwVNav20Th0mkoUNVSbF1W
y1bOUshHpXr+HIVps9wwsYKiusupOE1Fsa7N50JsIUXOLM1zzaZIrS/2mEil
2NSXO5l4mGL8oGX9vXiKPdLXl13kFB6L98TyKAphT6rdt2EU+mZxtxOkFD2f
b97rv42i49Un0xpPCt8GNffzFoqGlN/OWzhRHDVfcU/ZQBGcZX6o1VLr6RmS
OWFC8WnLubInQopjO7vv/q0hcM3T5FYvE1h8Hd4RMUuQmxGvfjZBIGpS0m9G
CCqz9tX23yQokKmExn8QLEqE0+6tBG3WUZl+TQRvrWtc5VZD4LVQz7/DEbyW
5auulxJ4r34ujCskKC+y9VzIIHA2vi3bqyBQ+bnUNcYRzCROhz+OJnhQY1ph
EEbgogk8+24gQcSbkmaBF8Gz9Bi9vzYT/BJ/8kaxiCC6X+nrbkUQH3Oddplo
/XafsPXQJXg8K9Ute8XDasO/GSNzPCaTM28IJ3jcPH3NwXqYx1Zv/pZ1H4/1
V3fpGLTzGHtZ9N/YRR5Duh/Nn6risWKUbrvtJx7z9obDwz/wyHve4hP2HY/L
FQ1VrYd5FObv9jaJ5eH05aEd2yN4lCvnzFKDtP1dxgMqbx6KkR3q0i08epLj
zXPsecyshIpklrz2NxIn8Voe/OCbnjYNB9GjdCvdKQ7ihyfuino5JL9wLLBv
4HA16TxdXcoht7699vejHKL1FQ7boziMdb/HdXlzGJcHHDez41A49TLVX5/D
/2FT4TQ=
    "]}, {Automatic}],
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{{3.8726052589894524`*^9, 3.872605288434741*^9}, {
   3.87260552066903*^9, 3.872605547202179*^9}, {3.872605592186302*^9, 
   3.8726056194218473`*^9}, {3.872605730833807*^9, 3.872605744755577*^9}, {
   3.8726058876193867`*^9, 3.872605902300733*^9}, 3.8726060594039593`*^9, 
   3.8726097221330595`*^9, 3.8726118255577517`*^9, 3.87261264702157*^9, 
   3.872668213980815*^9, 3.8726682805629873`*^9, 3.872668334048103*^9, 
   3.8726684916055927`*^9, 3.8726685550788865`*^9, 3.8726686106005263`*^9, 
   3.872668669962678*^9, 3.872668731035847*^9, 3.8726687970948524`*^9, 
   3.8726688571733017`*^9, 3.8726688942345204`*^9, 3.8726689260693054`*^9, 
   3.874229834975417*^9, 3.874229913751953*^9, 3.874230001081788*^9, 
   3.874230060827942*^9, 3.8744850657949004`*^9, 3.921166689153599*^9, 
   3.9211667529355373`*^9},
 CellLabel->"Out[94]=",ExpressionUUID->"b880bea6-0827-4f58-b19e-5d373754bf44"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"cov", "=."}], ";", 
  RowBox[{
   RowBox[{"cov", "[", "r_", "]"}], "=", 
   RowBox[{"Exp", "[", 
    RowBox[{
     RowBox[{"-", ".1"}], "r"}], "]"}]}], ";", " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "For", " ", "left", " ", "panel", " ", "of", " ", "Figure", " ", "2"}], 
   " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.872609534018862*^9, 3.8726095787528152`*^9}, {
  3.8726680393749747`*^9, 3.8726681038148603`*^9}, {3.9211661759007816`*^9, 
  3.9211661819402113`*^9}, {3.9211663760520487`*^9, 3.921166418827866*^9}},
 CellLabel->"In[60]:=",ExpressionUUID->"712aa713-0a25-4bba-b72a-993923c155fd"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"k1", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", ".5"}], 
     RowBox[{"D", "[", 
      RowBox[{
       RowBox[{"cov", "[", "r", "]"}], ",", "r"}], "]"}]}], "/.", 
    RowBox[{"r", "->", "1"}]}]}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "For", " ", "left", " ", "panel", " ", "of", " ", "Figure", " ", "2", " ", 
    "and", " ", "Figure", " ", "3"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"k0", "=", 
   RowBox[{"-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"cov", "[", "1", "]"}], "+", "k1"}], " ", ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"covx", "=."}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"covx", "[", "r_", "]"}], "=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"cov", "[", "r", "]"}], "+", "k0", "+", 
          RowBox[{"k1", " ", 
           RowBox[{"r", "^", "2"}]}]}], ")"}], ",", 
        RowBox[{"r", "<", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"r", ">=", "1"}]}], "}"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"covx", "[", "r", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"r", ",", "0", ",", "2"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.8726061077862377`*^9, 3.872606110672361*^9}, {
   3.872609595122451*^9, 3.872609595377182*^9}, 3.9211663822046413`*^9, 
   3.921166412292609*^9},
 CellLabel->"In[96]:=",ExpressionUUID->"a5672d09-7492-4882-83ed-1fd11c70d070"],

Cell[BoxData["151.60964248223146`"], "Output",
 CellChangeTimes->{
  3.8726053057207413`*^9, 3.872606075553093*^9, 3.8726061118395*^9, {
   3.872609561999585*^9, 3.872609595830401*^9}, 3.872609738573412*^9, 
   3.8726117555488043`*^9, 3.8726118405729537`*^9, 3.872612661288627*^9, 
   3.872667919718277*^9, 3.8726682284999743`*^9, 3.8726682949619293`*^9, 
   3.872668506010337*^9, 3.8726685692390676`*^9, 3.8726686246344786`*^9, 
   3.8726686843059187`*^9, 3.8726687448036423`*^9, 3.872668811652788*^9, 
   3.872668871088503*^9, 3.872668908271593*^9, 3.8726689403896666`*^9, 
   3.874229852258794*^9, 3.8742299740540276`*^9, 3.87423001508141*^9, 
   3.8742300745311756`*^9, 3.874485085284427*^9, 3.8806418180904803`*^9, 
   3.921166458438716*^9, 3.9211665424966536`*^9, 3.92116670312388*^9, 
   3.92116675298244*^9},
 CellLabel->"Out[96]=",ExpressionUUID->"4bd0309c-09cf-4058-89c8-a384c6ea7fbe"],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    TagBox[
     {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
      1.], LineBox[CompressedData["
1:eJxF0Xk4lVsXAPBj6MuNzHLJcIhzkeQrkQZrGyqZrhMZrjGdg3zVRadQCkWG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       "]]},
     Annotation[#, "Charting`Private`Tag$12978#1"]& ]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  Method->{
   "DefaultBoundaryStyle" -> Automatic, 
    "DefaultGraphicsInteraction" -> {
     "Version" -> 1.2, "TrackMousePosition" -> {True, False}, 
      "Effects" -> {
       "Highlight" -> {"ratio" -> 2}, "HighlightPoint" -> {"ratio" -> 2}, 
        "Droplines" -> {
         "freeformCursorMode" -> True, 
          "placement" -> {"x" -> "All", "y" -> "None"}}}}, "DefaultMeshStyle" -> 
    AbsolutePointSize[6], "ScalingFunctions" -> None, 
    "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{0, 2}, {0., 198.9537260933489}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.8726053057207413`*^9, 3.872606075553093*^9, 3.8726061118395*^9, {
   3.872609561999585*^9, 3.872609595830401*^9}, 3.872609738573412*^9, 
   3.8726117555488043`*^9, 3.8726118405729537`*^9, 3.872612661288627*^9, 
   3.872667919718277*^9, 3.8726682284999743`*^9, 3.8726682949619293`*^9, 
   3.872668506010337*^9, 3.8726685692390676`*^9, 3.8726686246344786`*^9, 
   3.8726686843059187`*^9, 3.8726687448036423`*^9, 3.872668811652788*^9, 
   3.872668871088503*^9, 3.872668908271593*^9, 3.8726689403896666`*^9, 
   3.874229852258794*^9, 3.8742299740540276`*^9, 3.87423001508141*^9, 
   3.8742300745311756`*^9, 3.874485085284427*^9, 3.8806418180904803`*^9, 
   3.921166458438716*^9, 3.9211665424966536`*^9, 3.92116670312388*^9, 
   3.9211667530214844`*^9},
 CellLabel->
  "Out[100]=",ExpressionUUID->"31077b27-20f0-42ef-8fd6-29f6af830bbf"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.880638901683379*^9, 3.8806389019181647`*^9}, 
   3.880638972781726*^9},ExpressionUUID->"f50b349b-0fb1-40b9-922c-\
992be9d31ad6"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.880638908344589*^9, 
  3.8806389799183397`*^9}},ExpressionUUID->"ca46100d-af9d-4570-b0e9-\
2596994f0926"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "For", " ", "left", " ", "panel", " ", "of", " ", "Figure", " ", "2", " ", 
    "and", " ", "Figure", " ", "3"}], " ", "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"A", "=", 
     RowBox[{"ParallelTable", "[", 
      RowBox[{
       RowBox[{"covx", "[", 
        RowBox[{"Norm", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"n", " ", "-", 
             RowBox[{"Abs", "[", " ", "i", "]"}]}], ",", 
            RowBox[{"n", "-", 
             RowBox[{"Abs", "[", "j", "]"}]}]}], "}"}], "/", 
          RowBox[{"(", 
           RowBox[{"1.0", "n"}], ")"}]}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"-", "n"}], ",", 
         RowBox[{"n", "-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", 
         RowBox[{"-", "n"}], ",", 
         RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"A", "=", 
     RowBox[{"Fourier", "[", "A", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Min", "[", 
    RowBox[{"Re", "[", "A", "]"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"v", "=", 
     RowBox[{
      RowBox[{"Sqrt", "[", "n", "]"}], 
      RowBox[{
       RowBox[{"Re", "[", 
        RowBox[{"Fourier", "[", 
         RowBox[{
          RowBox[{"Sqrt", "[", "A", "]"}], "Z0"}], "]"}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"1", ";;", "m"}], ",", 
         RowBox[{"1", ";;", "m"}]}], "]"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"v", "=", 
     RowBox[{"v", "+", 
      RowBox[{
       RowBox[{"Sqrt", "[", 
        RowBox[{"2", "k1"}], "]"}], 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Zs", "[", 
            RowBox[{"[", "1", "]"}], "]"}], 
           RowBox[{"i", "/", "n"}]}], "+", 
          RowBox[{
           RowBox[{"Zs", "[", 
            RowBox[{"[", "2", "]"}], "]"}], 
           RowBox[{"j", "/", "n"}]}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", "m"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "1", ",", "m"}], "}"}]}], "]"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"v", "=", 
     RowBox[{"v", "-", 
      RowBox[{"v", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.872605016138397*^9, 3.872605033020891*^9}, 
   3.8726054232914286`*^9, 3.872606209154064*^9, 3.872667597655816*^9, {
   3.8806388951035633`*^9, 3.880638900343749*^9}, {3.9211662444923167`*^9, 
   3.921166266421347*^9}, {3.9211663901088595`*^9, 3.921166397835701*^9}},
 CellLabel->
  "In[101]:=",ExpressionUUID->"d0bb3652-a351-4004-8656-69731aeb79aa"],

Cell[BoxData[
 RowBox[{"-", "0.000031985940927453214`"}]], "Output",
 CellChangeTimes->{3.9211667695783854`*^9},
 CellLabel->
  "Out[103]=",ExpressionUUID->"5e16de69-2151-45f2-bd30-d9fac5db4a0b"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.872667586230917*^9, 3.872667595529275*^9}, {
   3.8806389275525465`*^9, 3.880638953251621*^9}, 
   3.9211662424980526`*^9},ExpressionUUID->"42a8d05b-d6d4-4379-9f36-\
1ca5f04bc46a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"For", " ", "Figure", " ", "2", " ", "right", " ", "panel"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"v", "=", 
    RowBox[{"Accumulate", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"Accumulate", "[", 
       RowBox[{"RandomVariate", "[", 
        RowBox[{
         RowBox[{"NormalDistribution", "[", 
          RowBox[{"0", ",", "1"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"m", ",", "m"}], "}"}]}], "]"}], "]"}], "]"}], "]"}]}], 
   ";"}]}]], "Input",
 CellChangeTimes->{{3.872667628803439*^9, 3.8726676672776403`*^9}, {
  3.9211662697481174`*^9, 3.9211662854044313`*^9}},
 CellLabel->
  "In[114]:=",ExpressionUUID->"c5a7f930-b5dc-4a49-ac25-36f8a352cb0f"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"rp", "=", 
    RowBox[{"ReliefPlot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"v", "[", 
        RowBox[{"[", 
         RowBox[{"1", ";;", "m"}], "]"}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"1", ";;", 
         RowBox[{"Ceiling", "[", 
          RowBox[{"0.6", "m"}], "]"}]}], "]"}], "]"}], ",", 
      RowBox[{"Frame", "\[Rule]", "False"}]}], "]"}]}], "\[IndentingNewLine]",
    "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.872605428110217*^9, 3.872605429525441*^9}, 
   3.8726054986054897`*^9, {3.8726057632718287`*^9, 3.8726057672878027`*^9}, {
   3.8726062679537745`*^9, 3.8726062735297117`*^9}, {3.8726063465302*^9, 
   3.8726063481857495`*^9}, {3.8726064956296525`*^9, 
   3.8726065076392713`*^9}, {3.872606611109548*^9, 3.8726066517792473`*^9}, {
   3.8726067683810797`*^9, 3.8726068982295685`*^9}, {3.8726069398212605`*^9, 
   3.872607054110197*^9}, {3.8726070866149015`*^9, 3.872607148654356*^9}, {
   3.872607216295455*^9, 3.872607254494712*^9}, {3.872609472865515*^9, 
   3.872609476440523*^9}, {3.872609630498152*^9, 3.8726096307303452`*^9}, {
   3.8726673815303593`*^9, 3.872667401180185*^9}, {3.8726674653424606`*^9, 
   3.8726674686422157`*^9}, 3.872667581943139*^9, {3.872667620880518*^9, 
   3.8726676236206512`*^9}, {3.87266770973225*^9, 3.872667709956567*^9}, {
   3.874230554090784*^9, 3.874230565928007*^9}, 3.874231066192373*^9, {
   3.880641839831301*^9, 3.880641881471167*^9}},
 CellLabel->
  "In[115]:=",ExpressionUUID->"9601ad2a-16a1-45c2-a69a-4576bd8fceeb"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.921338576051956*^9, 
  3.9213385760609694`*^9}},ExpressionUUID->"efa4a089-42d5-4e37-83cb-\
c785018a8ed3"]
},
WindowSize->{1525.2, 788.4},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"13.0 for Microsoft Windows (64-bit) (February 4, 2022)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"ee6083d1-de4b-46c5-9f1b-3a3161535004"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1421, 42, 136, "Input",ExpressionUUID->"eb73507e-d015-434d-907a-20be94b15e6e"],
Cell[1982, 64, 728, 21, 36, "Input",ExpressionUUID->"c0bdc856-5145-46e0-82a3-3a5d6fc67b4e"],
Cell[2713, 87, 857, 26, 36, "Input",ExpressionUUID->"fc9044ad-4c59-480f-b4e0-aaf4aa07e979"],
Cell[CellGroupData[{
Cell[3595, 117, 2560, 72, 210, "Input",ExpressionUUID->"ffacb91f-7675-4c3c-a371-b4d026ce727a"],
Cell[6158, 191, 1554, 36, 94, "Output",ExpressionUUID->"e1cafed2-4933-4b84-9f9a-8f2f115841c8"],
Cell[7715, 229, 960, 14, 41, "Output",ExpressionUUID->"5662886d-122d-4016-b40e-569fad55d441"],
Cell[8678, 245, 17161, 330, 80, "Output",ExpressionUUID->"b880bea6-0827-4f58-b19e-5d373754bf44"]
}, Open  ]],
Cell[25854, 578, 636, 15, 36, "Input",ExpressionUUID->"712aa713-0a25-4bba-b72a-993923c155fd"],
Cell[CellGroupData[{
Cell[26515, 597, 1622, 49, 136, "Input",ExpressionUUID->"a5672d09-7492-4882-83ed-1fd11c70d070"],
Cell[28140, 648, 895, 13, 41, "Output",ExpressionUUID->"4bd0309c-09cf-4058-89c8-a384c6ea7fbe"],
Cell[29038, 663, 6688, 129, 305, "Output",ExpressionUUID->"31077b27-20f0-42ef-8fd6-29f6af830bbf"]
}, Open  ]],
Cell[35741, 795, 177, 3, 36, "Input",ExpressionUUID->"f50b349b-0fb1-40b9-922c-992be9d31ad6"],
Cell[35921, 800, 154, 3, 36, "Input",ExpressionUUID->"ca46100d-af9d-4570-b0e9-2596994f0926"],
Cell[CellGroupData[{
Cell[36100, 807, 2924, 84, 260, "Input",ExpressionUUID->"d0bb3652-a351-4004-8656-69731aeb79aa"],
Cell[39027, 893, 195, 4, 41, "Output",ExpressionUUID->"5e16de69-2151-45f2-bd30-d9fac5db4a0b"]
}, Open  ]],
Cell[39237, 900, 229, 4, 36, "Input",ExpressionUUID->"42a8d05b-d6d4-4379-9f36-1ca5f04bc46a"],
Cell[39469, 906, 762, 20, 62, "Input",ExpressionUUID->"c5a7f930-b5dc-4a49-ac25-36f8a352cb0f"],
Cell[40234, 928, 1590, 31, 111, "Input",ExpressionUUID->"9601ad2a-16a1-45c2-a69a-4576bd8fceeb"],
Cell[41827, 961, 154, 3, 36, InheritFromParent,ExpressionUUID->"efa4a089-42d5-4e37-83cb-c785018a8ed3"]
}
]
*)

